import numpy as np
from sklearn.linear_model import LinearRegression
import matplotlib.pyplot as plt
from scipy.signal import argrelextrema

import requests
import json

url = 'http://192.168.99.1:8080/sma'
candlesResp = requests.get(url)
testSMA = json.loads(candlesResp.text)

# 准备数据
y = np.array(testSMA)
x = np.arange(1, y.size + 1)

minima_indices = argrelextrema(y, np.less)[0]
maxima_indices = argrelextrema(y, np.greater)[0]
print(minima_indices)
print(maxima_indices)

# 将 x 转为二维数组
X = x.reshape(-1, 1)

# 创建并拟合线性回归模型
model = LinearRegression()
model.fit(X, y)

# 获取斜率和截距
slope = model.coef_[0]
intercept = model.intercept_

print(f"Slope: {slope}, Intercept: {intercept}")

import matplotlib.pyplot as plt

# 绘制原始数据
plt.scatter(x, y, label='Original Data')

# 绘制相对极小值点和相对极大值点
plt.scatter(x[minima_indices], y[minima_indices], c='r', marker='o', label='Minima')
plt.scatter(x[maxima_indices], y[maxima_indices], c='g', marker='o', label='Maxima')

# 绘制拟合直线
plt.plot(x, model.predict(X), color='blue', label='Linear Fit')

#FIXME: 应该是回溯到第一个极大值点，然后再拟合一次
#可能需要通过大量的测试，找到最佳的k线参数组合，SMA参数和K线level，以及回溯的k线数量,数学方法?找到影响因子后，假设因子服从（复合分布，泊松分布？）,然后通过概率论计算出最佳的参数组合
#回溯第一个拐点吗？
#过去的拐点就是支撑或者顶
pos = minima_indices[-1]
x2,y2 = x[pos:], y[pos:]
X2 = x2.reshape(-1, 1)
model2 = LinearRegression()
model2.fit(X2, y2)
plt.plot(x2, model2.predict(X2), color='yellow', label='Linear Fit Begin')

plt.legend()
plt.show()