#/usr/bin/env python3

import csv
import sys

# 检查是否提供了文件名参数
if len(sys.argv) != 2:
    print("用法: python script.py <文件名>")
    sys.exit(1)

# 获取文件名
file_path = sys.argv[1]

# 读取文件内容
with open(file_path, 'r') as file:
    reader = csv.reader(file)
    data = [row for row in reader]

# 将第二项（索引为1）的值转换为整数并进行排序
sorted_data = sorted(data, key=lambda x: int(x[1]), reverse=True)

# 打印排序后的数据
for row in sorted_data[:10]:
    print(','.join(map(str, row)))

