#!/bin/env python3

import sys
from collections import defaultdict

file_path = "./round2-long/result-backtest-1d.json"

def readTestResult(filePath):
    data_list = []
    with open(filePath, 'r') as file:
        for line in file:
            parsed_line = eval(line.strip())
            data_list.append(parsed_line)
    #print(data_list[:5])
    return data_list


def filter_and_sort(data_list):
    # 使用defaultdict来存储第二项和第三项相等的行
    match_dict = defaultdict(list)
    
    # 遍历数据，将相同(第二项, 第三项)的行放入字典
    for item in data_list:
        key = (item[1], item[2])
        match_dict[key].append(item)
    
    # 只保留那些有相同行的项
    filtered_list = [item for sublist in match_dict.values() if len(sublist) > 1 for item in sublist]
    
    # 按照第四项进行排序
    sorted_list = sorted(filtered_list, key=lambda x: x[3])
    return sorted_list

if __name__ == "__main__":
    # 获取命令行参数传递的文件路径
    if len(sys.argv) != 3:
        print("Usage: python script.py <file1_path> <file2_path>")
        sys.exit(1)

    file1_path = sys.argv[1]
    file2_path = sys.argv[2]

    # compare
    ret1 = readTestResult(file1_path)
    ret2 = readTestResult(file2_path)
    ret=[]
    # K线级别      (初始10万)最终净资产    手续费  次数    止损4   止盈5    胜率6   [资产最低，最高，最后]
    for a in ret1:
        for b in ret2:
            if a[0] == b[0] and a[5] == b[5] and a[6] == b[6]:
                ret.append([a[0], a[5], a[6], a[1], b[1], b[1]-a[1], b[3]-a[3], b[4]-a[4], a[7], b[7], round(b[7]-a[7], 2)])
    
    for each in ret:
        #print("\t".join(f"{str(x)}" for x in each)) # 无右对齐
        #formatted_item = [f"{str(x):>10}" for x in each] #仅右对齐
        formatted_item = [ f"{str(x):>10}" if isinstance(x, (int, float)) else str(x) for x in each ]
        print("\t".join(formatted_item))

	
