#!/usr/bin/env python3

import csv
import sys

if len(sys.argv) != 2:
    print("用法: python script.py <文件名>")
    sys.exit(1)

file_path = sys.argv[1]

with open(file_path, 'r') as file:
    reader = csv.reader(file)
    data = [row for row in reader]

sorted_data = sorted(data, key=lambda x: int(x[1]), reverse=True)

for row in sorted_data[:10]:
    print(','.join(map(str, row)))

