#include <iostream>
#include <vector>
#include <cmath>
#include <numeric>
#include <algorithm>
#if 0
std::vector<size_t> findInflectionPoints(const std::vector<double>& data, double threshold = 0.0001) {
    std::vector<size_t> inflectionPoints;
    
    if (data.size() < 3) return inflectionPoints;

    // 计算平均值和标准差
    double mean = std::accumulate(data.begin(), data.end(), 0.0) / data.size();
    double sq_sum = std::inner_product(data.begin(), data.end(), data.begin(), 0.0);
    double stdev = std::sqrt(sq_sum / data.size() - mean * mean);

    // 用于检测趋势的辅助变量
    double prev_slope = 0;
    bool trend_started = false;
    size_t trend_start = 0;

    for (size_t i = 1; i < data.size() - 1; ++i) {
        double current_slope = data[i+1] - data[i];
        
        // 检测趋势的开始或结束
        if (std::abs(current_slope) > threshold * stdev) {
            if (!trend_started) {
                trend_started = true;
                trend_start = i;
            }
        } else if (trend_started) {
            // 趋势结束，检查是否为拐点
            if (std::abs(data[i] - data[trend_start]) > threshold * stdev) {
                inflectionPoints.push_back(trend_start);
                inflectionPoints.push_back(i);
            }
            trend_started = false;
        }

        prev_slope = current_slope;
    }

    // 检查最后一个趋势
    if (trend_started && std::abs(data.back() - data[trend_start]) > threshold * stdev) {
        inflectionPoints.push_back(trend_start);
        inflectionPoints.push_back(data.size() - 1);
    }

    return inflectionPoints;
}
#else
std::vector<size_t> findInflectionPoints(const std::vector<double>& data, double threshold = 0.0001) {
    std::vector<size_t> inflectionPoints;
    
    if (data.size() < 3) return inflectionPoints;

    // 计算平均值和标准差
    double mean = std::accumulate(data.begin(), data.end(), 0.0) / data.size();
    double sq_sum = std::inner_product(data.begin(), data.end(), data.begin(), 0.0);
    double stdev = std::sqrt(sq_sum / data.size() - mean * mean);

    // 用于检测趋势的辅助变量
    double prev_slope = data[1] - data[0];
    int trend = (prev_slope > 0) ? 1 : (prev_slope < 0) ? -1 : 0;
    size_t trend_start = 0;

    for (size_t i = 1; i < data.size() - 1; ++i) {
        double current_slope = data[i+1] - data[i];
        int current_trend = (current_slope > 0) ? 1 : (current_slope < 0) ? -1 : 0;
        
        // 检测趋势的变化
        if (current_trend != trend && std::abs(current_slope - prev_slope) > threshold * stdev) {
            if (i - trend_start > 1) {  // 确保趋势持续一段时间
                inflectionPoints.push_back(i);
            }
            trend = current_trend;
            trend_start = i;
        }

        prev_slope = current_slope;
    }

    return inflectionPoints;
}
#endif

int main() {
    //std::vector<double> data = {67290.9, 67296.1, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67301.3, 67294.5, 67287.6, 67280.8, 67274, 67267.1, 67260.3, 67253.5, 67246.6, 67239.8, 67233, 67226.1, 67219.3, 67212.5, 67205.6, 67198.8, 67192, 67185.1, 67178.3, 67171.4, 67164.6, 67157.8, 67150.9, 67144.1, 67137.3, 67130.4, 67123.6, 67116.8, 67109.9, 67103.1, 67096.3, 67089.4, 67082.6, 67075.8, 67068.9, 67062.1, 67055.3, 67048.4, 67041.6, 67034.7, 67027.9, 67021.1, 67014.2, 67007.4, 67000.6, 66993.7, 66986.9, 66980.1, 66973.2, 66966.4, 66959.6, 66952.7, 66945.9, 66939.1, 66932.2, 66925.4, 66918.6, 66911.7, 66904.9};
    //std::vector<double> data = {100, 101, 102, 103, 104, 100, 99, 98, 105, 110};
    std::vector<double> data = {100, 101, 102, 101, 100, 101, 100, 108, 100, 110};
    
    auto inflectionPoints = findInflectionPoints(data);
    
    std::cout << "拐点位置：" << std::endl;
    for (auto point : inflectionPoints) {
        std::cout << point << " (值: " << data[point] << ")" << std::endl;
    }
    
    return 0;
}
