#include <iostream>
#include <vector>

// 查找局部极大值的索引
std::vector<int> findLocalMaxima(const std::vector<double>& data, int order=1) {
    std::vector<int> indices;

    for (int i = order; i < data.size() - order; ++i) {
        bool isMaxima = true;
        for (int j = 1; j <= order; ++j) {
            if (data[i] <= data[i - j] || data[i] <= data[i + j]) {
                isMaxima = false;
                break;
            }
        }
        if (isMaxima) {
            indices.push_back(i);
        }
    }
    return indices;
}

// 查找局部极小值的索引
std::vector<int> findLocalMinima(const std::vector<double>& data, int order=1) {
    std::vector<int> indices;

    for (int i = order; i < data.size() - order; ++i) {
        bool isMinima = true;
        for (int j = 1; j <= order; ++j) {
            if (data[i] >= data[i - j] || data[i] >= data[i + j]) {
                isMinima = false;
                break;
            }
        }
        if (isMinima) {
            indices.push_back(i);
        }
    }
    return indices;
}

int main() {
    //std::vector<double> data = {1, 3, 2, 5, 4, 7, 6, 9, 8};
    std::vector<double> data = {101, 103, 105, 108, 107, 106, 104, 102, 100, 98, 97, 95, 96};

    // 找到局部最大值和最小值的索引
    std::vector<int> max_indices = findLocalMaxima(data);
    std::vector<int> min_indices = findLocalMinima(data);

    // 打印局部最大值的索引
    std::cout << "局部最大值的索引: ";
    for (int index : max_indices) {
        std::cout << index << " ";
    }
    std::cout << std::endl;

    // 打印局部最小值的索引
    std::cout << "局部最小值的索引: ";
    for (int index : min_indices) {
        std::cout << index << " ";
    }
    std::cout << std::endl;

    return 0;
}

